﻿/*
Ригин Антон Михайлович, ПИ ФКН НИУ ВШЭ, группа БПИ154.
Курсовая работа на 1-м курсе.
Тема курсовой работы: "Программа нейросетевого решения дифференциальных уравнений в частных производных".
Файл LinearActivationFunction.cs библиотеки классов DiffEqNeuroLibrary, содержит класс LinearActivationFunction, задающий линейную функцию активации y = x.
*/

using AForge.Neuro; // Для представления структуры нейросетей используется AForge.NET Framework.

namespace DiffEqNeuroLibrary
{
    /// <summary>
    /// Задает линейную функцию активации y = x.
    /// </summary>
    public class LinearActivationFunction : IActivationFunction
    {
        /// <summary>
        /// Возвращает x.
        /// </summary>
        /// <param name="x">Аргумент x.</param>
        /// <returns>Возвращает x.</returns>
        public double Function(double x)
        {
            return x;
        }

        /// <summary>
        /// Возвращает 1.
        /// </summary>
        /// <param name="x">Аргумент x.</param>
        /// <returns>Возвращает 1.</returns>
        public double Derivative(double x)
        {
            return 1;
        }

        /// <summary>
        /// Возвращает 1.
        /// </summary>
        /// <param name="y">Аргумент y.</param>
        /// <returns>Возвращает 1.</returns>
        public double Derivative2(double y)
        {
            return 1;
        }

        /// <summary>
        /// Возвращает 0.
        /// </summary>
        /// <param name="x">Аргумент x.</param>
        /// <returns>Возвращает 0.</returns>
        public double SecondDerivative(double x)
        {
            return 0;
        }

        /// <summary>
        /// Возвращает 0.
        /// </summary>
        /// <param name="y">Аргумент y.</param>
        /// <returns>Возвращает 0.</returns>
        public double SecondDerivative2(double y)
        {
            return 0;
        }

        /// <summary>
        /// Возвращает 0.
        /// </summary>
        /// <param name="x">Аргумент x.</param>
        /// <returns>Возвращает 0.</returns>
        public double ThirdDerivative(double x)
        {
            return 0;
        }

        /// <summary>
        /// Возвращает 0.
        /// </summary>
        /// <param name="y">Аргумент y.</param>
        /// <returns>Возвращает 0.</returns>
        public double ThirdDerivative2(double y)
        {
            return 0;
        }
    }
}